#ifndef _H_QMATH_EXPRESSION
#define _H_QMATH_EXPRESSION

#include <stdarg.h>

// STL
#include <string>
#include <list>

#include "QMATH_types.H"
//#include "QMATH_Evaluator.H"
typedef class QMATH_Evaluator *P_QMATH_Evaluator;

typedef enum
{//     Basic objects
  //           Implementation:  Type:
  none,       //  -------------bugtrap
  integer,    //  char*        Bignum (array of digits of unlimited lenght).
  fp_number,  //  double       IEEE 754-1985 standard.
  char_string,//  wchar*       Unicode wide char array.
  byte_array, //  char*        Byte array.
  symbol,     //  char*        OpenMath symbol (ASCII char string).
  variable,   //  char*        OpenMath variable (ASCII char string).
  //    Constructs
  application,
  attribution,
  binding,
  error,
  //    Top level math expression
  math
} om_object_type_t;

unsigned int const qmath_version = 0x00020000;

class QMATH_Expression
{
public:
  QMATH_Expression ();
  QMATH_Expression (int num_items, ...);       //  Construct
  QMATH_Expression (const c_string new_string);//  Basic object

  QMATH_Expression* Type (om_object_type_t new_object_type);
  om_object_type_t Type ();
  char* Basic_object ();
  QMATH_Expression &Object (int object_index);
  int Object_count ();// Returns 0 for basic objects.
  bool Symbol (string* p_value);
  void Evaluate ();
  bool Select_evaluator (c_string new_evaluator_module);
private:
  static P_QMATH_Evaluator p_evaluator;

  om_object_type_t object_type;

  c_string basic_object;
  list<QMATH_Expression> construct;
  list<QMATH_Expression>::iterator construct_iterator;

  bool Add_item (QMATH_Expression* p_new_item);
  bool Add_item (const c_string new_string);
};

extern ostream &operator<< (ostream &, QMATH_Expression&);

#endif
