// Evaluator_*.cc -- These functions are used only from QMATH_Evaluator_loader.
  
#include "../QMATH_Evaluator.H"

#include "Evaluator_default.H"

void Evaluator_default_Operator_default (QMATH_Expression &exp);
void Evaluator_default_Operator_And (QMATH_Expression &exp);
void Evaluator_default_Operator_Or (QMATH_Expression &exp);
void Evaluator_default_Operator_Xor (QMATH_Expression &exp);
void Evaluator_default_Operator_Not (QMATH_Expression &exp);
void Evaluator_default_Operator_Abs (QMATH_Expression &exp);
void Evaluator_default_Operator_Conjugate (QMATH_Expression &exp);
void Evaluator_default_Operator_Inverse (QMATH_Expression &exp);
void Evaluator_default_Operator_Ident (QMATH_Expression &exp);
void Evaluator_default_Operator_Plus (QMATH_Expression &exp);
void Evaluator_default_Operator_Minus (QMATH_Expression &exp);
void Evaluator_default_Operator_Times (QMATH_Expression &exp);
void Evaluator_default_Operator_Divide (QMATH_Expression &exp);
void Evaluator_default_Operator_Factorial (QMATH_Expression &exp);
void Evaluator_default_Operator_Exp (QMATH_Expression &exp);
void Evaluator_default_Operator_Ln (QMATH_Expression &exp);
void Evaluator_default_Operator_Log (QMATH_Expression &exp);
void Evaluator_default_Operator_Sin (QMATH_Expression &exp);
void Evaluator_default_Operator_Cos (QMATH_Expression &exp);
void Evaluator_default_Operator_Tan (QMATH_Expression &exp);
void Evaluator_default_Operator_Sec (QMATH_Expression &exp);
void Evaluator_default_Operator_Csc (QMATH_Expression &exp);
void Evaluator_default_Operator_Cot (QMATH_Expression &exp);
void Evaluator_default_Operator_Sinh (QMATH_Expression &exp);
void Evaluator_default_Operator_Cosh (QMATH_Expression &exp);
void Evaluator_default_Operator_Tanh (QMATH_Expression &exp);
void Evaluator_default_Operator_Sech (QMATH_Expression &exp);
void Evaluator_default_Operator_Csch (QMATH_Expression &exp);
void Evaluator_default_Operator_Coth (QMATH_Expression &exp);
void Evaluator_default_Operator_Arcsin (QMATH_Expression &exp);
void Evaluator_default_Operator_Arccos (QMATH_Expression &exp);
void Evaluator_default_Operator_Arctan (QMATH_Expression &exp);
void Evaluator_default_Operator_Quotient (QMATH_Expression &exp);
void Evaluator_default_Operator_Power (QMATH_Expression &exp);
void Evaluator_default_Operator_Rem (QMATH_Expression &exp);
void Evaluator_default_Operator_Max (QMATH_Expression &exp);
void Evaluator_default_Operator_Min (QMATH_Expression &exp);
void Evaluator_default_Operator_Gcd (QMATH_Expression &exp);
void Evaluator_default_Operator_Mean (QMATH_Expression &exp);
void Evaluator_default_Operator_Sdev (QMATH_Expression &exp);
void Evaluator_default_Operator_Variance (QMATH_Expression &exp);
void Evaluator_default_Operator_Median (QMATH_Expression &exp);
void Evaluator_default_Operator_Mode (QMATH_Expression &exp);
void Evaluator_default_Operator_Interval (QMATH_Expression &exp);
void Evaluator_default_Operator_Set (QMATH_Expression &exp);
void Evaluator_default_Operator_Vector (QMATH_Expression &exp);
void Evaluator_default_Operator_Declare (QMATH_Expression &exp);
void Evaluator_default_Operator_Determinant (QMATH_Expression &exp);
void Evaluator_default_Operator_Transpose (QMATH_Expression &exp);
void Evaluator_default_Operator_Implies (QMATH_Expression &exp);
void Evaluator_default_Operator_Setdiff (QMATH_Expression &exp);
void Evaluator_default_Operator_Selector (QMATH_Expression &exp);
void Evaluator_default_Operator_Union (QMATH_Expression &exp);
void Evaluator_default_Operator_Intersect (QMATH_Expression &exp);
void Evaluator_default_Operator_Fn (QMATH_Expression &exp);
void Evaluator_default_Operator_Compose (QMATH_Expression &exp);
void Evaluator_default_Operator_Int (QMATH_Expression &exp);
void Evaluator_default_Operator_Sum (QMATH_Expression &exp);
void Evaluator_default_Operator_Product (QMATH_Expression &exp);
void Evaluator_default_Operator_Diff (QMATH_Expression &exp);
void Evaluator_default_Operator_Partialdiff (QMATH_Expression &exp);
void Evaluator_default_Operator_Forall (QMATH_Expression &exp);
void Evaluator_default_Operator_Exists (QMATH_Expression &exp);
void Evaluator_default_Operator_Root (QMATH_Expression &exp);

//  This is the public interface.
void Evaluator_default_Register (evaluator_table_entry &evaluator_entry)
{
  operator_table_entry operator_entry;
  evaluator_entry.name = "default";

  //  The default operator must be always present.
  operator_entry.name = "default";
  operator_entry.code = &Evaluator_default_Operator_default;
  evaluator_entry.operator_table.push_back(operator_entry);

  //  Here we register the rest of the operators.


}

//  The following function is only known to Evaluator_*_Opertor_default().
//  It seems that "const c_string" is considered just as "char*" instead
// of "const char*". I don't know why. But it was faster to circumvent it
// than finding the cause.
const char* Evaluator_default_Translate_atom (const char* basic_object)
{
  #include "Evaluator_default_atom_dictionary.icc"
  int index;
  index = 0;
  while (strcmp("", atom_dictionary[index][0]) != 0)
    {
      if (strcmp(basic_object, atom_dictionary[index][0]) == 0)
        break;
      ++index;
    }
  if (strcmp("", atom_dictionary[index][1]) == 0)
    return basic_object;
  else
    return atom_dictionary[index][1];
}

extern int nest_level;
//  The actual code for every operator.
//  The following functions are only known to the previous, *_Register().
//  If you want an operator to be an alias for another, do it in
// the *_Register() function above. It will be much easier to maintain.
void Evaluator_default_Operator_default (QMATH_Expression &exp)
{
  char* begin_object;
  char* end_object;
  
  switch (exp.Type())
    {
    case none:        begin_object = " NONE.";     end_object = "";      break;
    case integer:     begin_object = " INT.";      end_object = "";      break;
    case fp_number:   begin_object = " FP.";       end_object = "";      break;
    case char_string: begin_object = " STR.";      end_object = "";      break;
    case byte_array:  begin_object = " ARRAY.";    end_object = "";      break;
    case symbol:      begin_object = " SYM.";      end_object = "";      break;
    case variable:    begin_object = " VAR.";      end_object = "";      break;
    case application: begin_object = " APP(";      end_object = " )";    break;
    case attribution: begin_object = " ATT(";      end_object = " )";    break;
    case binding:     begin_object = " BIND(";     end_object = " )";    break;
    case error:       begin_object = " ERR(";      end_object = " )";    break;
    case math:        begin_object = " MATH(";     end_object = " )";    break;
    default:          begin_object = " UNKNOWN"; end_object = "";      break;
    }

  cout << begin_object;
  
  if (exp.Object_count() == 0)
    {
      cout << exp.Basic_object();
    }
  else
    {
      for (int index = 0; index < exp.Object_count(); ++index)
        exp.Object(index).Evaluate();
    }

  cout << end_object;
}

