#ifndef _H_QMATH_EVALUATOR
#define _H_QMATH_EVALUATOR

// STL
#include <list>
#include <string>

#include "QMATH_types.H"
#include "QMATH_Expression.H"

typedef struct
{
  string name;
  void (*code) (string &atom, string &output);
} atom_table_entry;

typedef struct
{
  string name;
  void (*code) (QMATH_Expression &exp);
} operator_table_entry;

typedef struct
{
  string name;
  list<operator_table_entry> operator_table;
  list<operator_table_entry>::iterator operator_table_iterator;
} evaluator_table_entry;

class QMATH_Evaluator
{
public:
  QMATH_Evaluator ();
  QMATH_Evaluator (c_string evaluator_class);
  void Select (c_string evaluator_class);
  void Apply (QMATH_Expression &exp);
private:
  list<evaluator_table_entry>::iterator selected_evaluator_iterator;
  list<operator_table_entry>::iterator Find_operator (string operator_name);
};

#endif




